/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */
/*
 *  JavaScript Interpreter
 *  The JavaScript Interpreter is used for executing JavaScript programs
 *  in EWB that control user events on buttons, restrict inputs on textlines
 *  and so on.
 *
 *  Developmened by: Institute of Artificial Intelligence & Robotics
 *                   of Xi'an Jiaotong University
 *
 *  Create by:      Tian Wenqiang
 *  Last modified:  2001-11-13 19:56
 */

/* JS host object class header */

#ifndef _JS_NATIVE_HOST_H_
#define _JS_NATIVE_HOST_H_

#include "js-types.h"
#include "js-scriptableobject.h"
#include "js-function.h"

class JSNativeHost: public JSScriptableObject, public JSFunction {
    public:
	static	const jsString_t	className;

    protected:
	jsClass_t	*clazz;
	void		*closure;

    public:
	static	jsClass_t *
			defaultClass();

	JSNativeHost(jsClass_t *clazz);
	JSNativeHost(JSScriptable *scriptable);

	void	*getClosure();
	void	setClosure(void *closure);

	/* instance methods */
	jsBool_t
		isInstanceOf(const jsString_t className);

	/* scriptable methods */
	jsString_t
		getClassName(JSContext *cx);

    	jsBool_t
		get(JSContext *cx, jsString_t name, JSScriptable *start,
			jsVal_t *value);
	jsBool_t
		get(JSContext *cx, int index, JSScriptable *start,
			jsVal_t *value);
	jsBool_t
		has(JSContext *cx, jsString_t name, JSScriptable *start);
	jsBool_t
		has(JSContext *cx, int index, JSScriptable *start);
	void	put(JSContext *cx, jsString_t name, JSScriptable *start,
			jsVal_t value);
	void	put(JSContext *cx, int index, JSScriptable *start,
			jsVal_t value);
	void	del(JSContext *cx, jsString_t name);
	void	del(JSContext *cx, int index);
	JSScriptable *
		getPrototype(JSContext *cx);
	void	setPrototype(JSContext *cx, JSScriptable *prototype);
	JSScriptable *
		getParentScope(JSContext *cx);
	void	setParentScope(JSContext *cx, JSScriptable *parent);
	jsVal_t *
		getIds(JSContext *cx, int *numIds);
	jsVal_t	getDefaultValue(JSContext *cx, jsType_t hint);
	jsBool_t
		hasInstance(JSContext *cx, JSScriptable *instance);

	/* function methods */
	jsVal_t	call(JSContext *cx, JSScriptable *scope, JSScriptable *thisObj,
			int numArgs, jsVal_t *args);
	JSScriptable *
		construct(JSContext *cx, JSScriptable *scope, int numArgs,
			jsVal_t *args);

	/* gc methods */
	void	mark(JSContext *cx);
	void	finalize(JSContext *cx);
};

#endif  /* _JS_NATIVE_HOST_H_ */
